import unit4.collectionsLib.Node;
import unit4.collectionsLib.List;

/**
 *     
 *
 * @author   ,   ,  , 
 * @version 2/8/2007
 */

public class PhoneBook
{
	private List<Contact> phoneBook;
	private int numOfContacts;
	
	public PhoneBook()
	{
		this.phoneBook = new List<Contact>();
		this.numOfContacts = 0;
	}
	
	public void addContact(String name, String phone)
	{
		Node<Contact> prev = null;
		Node<Contact> pos = this.phoneBook.getFirst();

		while(pos!=null && name.compareTo(pos.getInfo().getName()) > 0)
		{
			prev = pos;
			pos = pos.getNext();
		}

		this.phoneBook.insert(prev, new Contact(name,phone));
		this.numOfContacts++;
	}
	
	public void delContact(String name)
	{
		Node<Contact> pos = this.phoneBook.getFirst();

		while(name.compareTo(pos.getInfo().getName()) != 0)
			pos = pos.getNext();

		this.phoneBook.remove(pos);
		this.numOfContacts--;
	}	
	
	public String getPhone(String name)
	{
		Node<Contact> pos = this.phoneBook.getFirst();
	
		while(pos != null)
		{
			if(pos.getInfo().getName().equals(name))
				return(pos.getInfo().getPhone());
			pos = pos.getNext();
		}
		
		return(null);
	}
	
	public void setPhone(String name, String phone)
	{
		Node<Contact> pos = this.phoneBook.getFirst();

		while(name.compareTo(pos.getInfo().getName()) != 0)
			pos = pos.getNext();

		pos.getInfo().setPhone(phone);
	}
	
	public String[] getAllContactsNames()
	{
		String[] names = new String[this.numOfContacts];
		Node<Contact> pos = this.phoneBook.getFirst();
		
		for (int i = 0; i < this.numOfContacts; i++) 
		{
			names[i] = pos.getInfo().getName();
			pos = pos.getNext();
		}
		
		return(names);
	}
	

	public String toString()
	{
		String str = "";
		Node<Contact> pos = this.phoneBook.getFirst();
		
		while(pos != null)
		{
			str = str + String.format("%-20s %10s\n",pos.getInfo().getName(),pos.getInfo().getPhone());
			pos = pos.getNext();
		}
		
		return(str);
	}
}